; 	Christmas 2022 Star/snowflake size compo.     Entry by Bushy555.
;	For the VZ200/VZ300/Laser210/Laser310 Z80 8-bit platform.
;
;	The VZ/Laser uses the 6847 video chip, which, in text mode, only supports 32 chars wide by 16 chars height.
;	Therefore the first few lines of the 17 char height snowflake/star symbol scrolls off the screen.
;
; 	Assemble with PASMO assembler.
;		> PASMO VZENTRY.ASM VZENTRY.VZ
;
;
;	Fancy beauty entry.
;	No size optimisation was even attempted here as you can tell.
;
;	500 bytes.
;
;


	org	$8000-24

	defb	'VZF1'			; HEADER: vzmagic       	[04]
	defb	'FILENAME.VZ      '    	; HEADER: filename      	[17]
	defb	$F1			; HEADER: Filetype      	[01]
	defw	$8000			; HEADER: Start address 	[02]

	org	$8000			; *** Start of program execution at $8000.
	ld	hl, table
	ld	b, 0
print:	ld	a, (hl)
	call	$33A		; call print char rom routine
	inc	hl
	djnz	print
	ld	b, 167
print2:	ld	a, (hl)
	call	$33A		; call print char rom routine
	inc	hl
	djnz	print2

	di
roll0:	xor	b		; Roll first half of screen (256bytes)
	ld	hl, $7000
roll1:	ld	a, (hl)
	inc	a
	ld	(hl), a
	inc	hl
	djnz	roll1
	ld	b, 0		; Roll second half of screen (256bytes)
roll2:	ld	a, (hl)
	inc	a
	ld	(hl), a
	inc	hl
	djnz	roll2

	LD 	hl,0x6800
sync2:	BIT 	7,(hl)			; fancy wait retrace.
	jr	NZ,sync2
	LD 	hl,0x6800
sync3:	BIT 	7,(hl)			; fancy wait retrace.
	jr	Z,sync3

	jr	roll0


table:	db "            XX     XX    ",$0d
	db "            XXX   XXX    ",$0d
	db "            XXXX XXXX    ",$0d
	db "        XXXXXXXXXXXXXXXXX",$0d
	db "         XXXXXXXXXXXXXXX ",$0d
	db "          XXXXXXXXXXXXX  ",$0d
	db "           XXXXXXXXXXX   ",$0d
	db "            XXXXXXXXX    ",$0d
	db "           XXXXXXXXXXX   ",$0d
	db "          XXXXXXXXXXXXX  ",$0d
	db "         XXXXXXXXXXXXXXX ",$0d
	db "        XXXXXXXXXXXXXXXXX",$0d
	db "            XXXX XXXX    ",$0d
	db "            XXX   XXX    ",$0d
	db "            XX     XX    ",$0d
	db "            X       X         "
